// app版本号
var appVersion = '1.7.614';
// 渠道市场
var appChannel = 'tencent';
// 扩展api.setPrefs()、api.getPrefs()、removePrefs()使其支持直接存储、读取数组、对象字面量类型数据，调用方法：$api.setPrefs(key,value)、$api.getPrefs(key)、$api.removePrefs(key)
(function (window) {
    if (!window.$api){
        return;
    }
    $api.setPrefs = function (key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object' || typeof v == 'boolean') {//（数组或对象字面量） || 布尔值
                v = JSON.stringify(v);
                v = 'obj-' + v;
            } else {
                v = 'str-' + v;
            }
            api.setPrefs({
                key: key,
                value: v
            });
        }
    };
    $api.getPrefs = function (key) {
        var v = api.getPrefs({
            sync: true,
            key: key
        });
        if (!v) {
            return;
        }
        if (v.indexOf('obj-') === 0) {
            v = v.slice(4);
            return JSON.parse(v);
        } else if (v.indexOf('str-') === 0) {
            return v.slice(4);
        }
    };
    $api.removePrefs = function (key) {
        if (key) {
            api.removePrefs({
                key: key
            });
        }
    };
})(window);
export function getCommonParam() {
    var commonParam = '',
        systemType = api.systemType,
        deviceId = api.deviceId,
        model = api.deviceModel,
        systemVersion = api.systemVersion,
        channel = '';

    if (systemType == 'ios') { //判断是否是ios平台
        isIos = true;

        channel = 0; //ios渠道id
    } else {
        isIos = false;

        channel = 1; //android渠道id
    }

    commonParam = '?app_version=' + appVersion + '&system=' + systemType + '&deviceId=' + deviceId + '&model=' + model + '&systemVersion=' + systemVersion + '&channel=' + channel +'&appChannel=' + appChannel;

    // 获取登录信息
    // 全局userInfo
    userInfo = $api.getPrefs('userInfo');
    // console.log('userInfo:'+$api.jsonToStr(userInfo));
    if (userInfo) {
        commonParam += '&zxb_token=' + userInfo.zxb_token + '&zxb_id=' + userInfo.zxb_id;
    }

    var registrationId = $api.getStorage('registrationId')
    if(registrationId) {
        commonParam += '&registration_id=' + registrationId;
    }

    // var txBugly = api.require('txBugly');
    // txBugly.setUserValue({
    //     key: 'userInfo',
    //     value: commonParam
    // });

    console.log('commonParam:'+commonParam);

    return commonParam;
}

export function ajaxRequest(opts) {
    var url = 'https://www.zixueb.cn/appapi';
    opts.url = opts.needPrefixUrl === false ? opts.url : (url + opts.url);

    // console.log(api.winName+' ajax url:' + opts.url)
    var complete = opts.complete,
        success = opts.success,
        error = opts.error,
        done = opts.done,
        autoHideLoading = opts.autoHideLoading,
        needReterror = opts.needReterror;//needReterror=true,即ret.error交由success回调处理

    if (opts.loading != false) {
        // 显示加载中
        showLoading(opts.loading);
    }
    api.ajax(opts, function (ret, err) {
        // 隐藏加载中
        if(autoHideLoading!=false){
            hideLoading();
        }
        // console.log('请求complete:'+new Date().toLocaleTimeString())
        complete && complete(opts, ret, err);
        if (ret) {
            // console.log('ajax请求数据成功：' + JSON.stringify(ret))
            if (ret.error && ((ret.error != 1 && ret.error != 30001) && !(needReterror === true))) { // 服务器请求成功 && (非30001“需要重新登录”(30001，重新登录，页面内success回调中执行) && 未显示声明为needReterror:true)
                hideLoading();
                api.toast({
                    msg: ret.msg,
                    duration: 2000,
                    location: 'middle'
                });
                return;
            }

            // console.log('ajax请求成功:' + opts.url)
            success && success(ret);
        } else {
            // console.log('ajax请求数据失败：' + JSON.stringify(err))
            if(error){
                error(err);
            }else{
                api.toast({
                    msg: err.msg,
                    duration: 4000,
                    location: 'middle'
                });
            }
        }
        // console.log('请求done:'+new Date().toLocaleTimeString())
        done && done(opts, ret, err);
    });
}

// 隐藏加载中提示层
function hideLoading() {
    var loadingWrap = $api.dom('.loading-wrap');
    $api.remove(loadingWrap);
}
