// ios 内购列表、监听等相关
// 服务器生成ios订单号接口url
var iosOrderUrl = '/v1/pay/ios_order.php';
// iap模块
var iap = api.require('iap');

//获取vip内购项目列表
function getVipProducts() {
    // 加载apple store vip套餐内购项目
    var productIdArr=['0012','0013','0014','0015'];
    iap.getProducts({
        productIds: productIdArr
    }, function(ret, err) {
        if (ret) {
            // console.log('产品信息1:'+JSON.stringify(ret));
            var products=ret.products;
            api.sendEvent({
                name: 'gotVipProducts',
                extra: {
                    products:products
                }
            });
        } else {
            alert(JSON.stringify(err));
        }
    });
}
//获取学习币充值内购项目列表
// productidarr_: 接入所有iap 内购后才有该参数传入(execScript传的是字符串，需手动转成数组格式)，旧版内购项目id是固定的
api.addEventListener({
    name: 'getIapidListEvent'
}, function(ret, err) {
    var productIdArr=ret.value.productIdArr;

    getRechargeProducts(productIdArr);
});

function getRechargeProducts(productidarr_) {
    // 加载apple store 充值内购项目
    if(productidarr_){
        // console.log('productidarr_:'+productidarr_);
        var productIdArr=productidarr_;
    }else{
        var productIdArr=['0001','0002','0003','0004','0005','0006'];
    }
    

    iap.getProducts({
        productIds: productIdArr
    }, function(ret, err) {
        if (ret) {
            // console.log('产品信息3:'+JSON.stringify(ret));
            var products=ret.products;
            api.sendEvent({
                name: 'gotRechargeProducts',
                extra: {
                    products:products
                }
            });
        } else {
            alert(JSON.stringify(err));
        }
    });
}

// iap监听
api.addEventListener({
    name: 'startPurchase'
}, function(ret, err){
    // 特别注意：传入getProducts方法productIds参数中的iap商品id 必须是字符串
    // fromePage:标识从哪个窗口页面调起iap
    var val=ret.value,
        id_=String(val.id);

    console.log('id_:'+id_)
    
    // 拉起iap支付,若app异常退出，完成支付，重新打开app后，iap交易监听会有setTransactionListener回调，固需要存储startPurchase事件参数供setTransactionListener获取参数使用
    $api.setPrefs('iapInitEventVal', val);
    
    var optParam = val.iosOrderOptPagram;
    iap.getProducts({
        productIds:[id_]
    }, function(ret, err) {
        if (ret) {
            // console.log('getProducts产品信息:'+JSON.stringify(ret));
            var productId_=ret.products[0].productId;
            // 服务器生成ios订单号
            console.log('生成订单：'+iosOrderUrl+optParam);
            ajaxRequest({
                url: iosOrderUrl + optParam,
                method: 'get',
                complete: function (opts, ret, err) {
                    console.log(api.winName + ' ajax url:' + opts.url)

                },
                success: function (ret) {
                    console.log('生成订单回调：'+$api.jsonToStr(ret));
                    $api.setPrefs('severOutTradeNo', ret.data.out_trade_no);

                    // 生成订单再调苹果支付
                    iap.purchase({
                        productId: productId_
                    }
                        // , function(ret, err) {
                        //     // 所有的商品交易状态都将会通过setTransactionListener回调返回，而不再通过purchase和restoreTransactions方法的回调返回
                        //
                        //
                        // }
                    );
                },
                error: function (err) {
                    showReloadTips();
                }
            });
        } else {
            alert(err.msg);
            console.log('获取产品错误信息:'+JSON.stringify(err));
        }
    });
});

// iap设置交易监听
iap.setTransactionListener(function(ret, err) {
    if (ret) {
        console.log('setTransactionListener回调:'+JSON.stringify(ret));
        var state=ret.state,
            errorCode=ret.errorCode?ret.errorCode:'';
        // 当前正在交易的商品id,供finishTransaction使用
        retProductId=ret.productId;
        // console.log('苹果回调执行一次');

        
        var severOutTradeNo = $api.getPrefs('severOutTradeNo');
        var iapInitEventVal=$api.getPrefs('iapInitEventVal');
        // console.log('iapInitEventVal' + JSON.stringify(iapInitEventVal))

        var fromPage = iapInitEventVal.fromPage,
            isVip = iapInitEventVal.isVip,
            vccid = iapInitEventVal.vccid,
            payPrice = iapInitEventVal.payPrice,
            purchaseType = iapInitEventVal.purchaseType,
            payMonth = iapInitEventVal.payMonth;

        // 服务器更新ios订单号信息
        var optParam = iapInitEventVal.iosOrderOptPagram + '&out_trade_no=' + severOutTradeNo+'&state='+state+'&errorCode='+errorCode;
        console.log('更新订单：'+iosOrderUrl+optParam);
        ajaxRequest({
            url: iosOrderUrl + optParam,
            method: 'get',
            complete: function (opts, ret, err) {
                // console.log(api.winName + ' ajax url:' + opts.url)

            },
            success: function (ret) {
                console.log('更新订单信息回调：' + $api.jsonToStr(ret));
            },
            error: function (err) {
                showReloadTips();
            }
        });

        if(state==1){//交易完成
            // 返回交易订单给服务器
            if(purchaseType=='vip-purchase'){//开通、续费vip
                var postData={
                    values:{
                        vip_id:vccid,
                        price:payPrice,
                        system:'ios',
                        buy_item:2,
                        // month:payMonth,
                        // pay_type:3,
                        transactionId:ret.transactionId,
                        receipt:ret.receipt,
                        out_trade_no: severOutTradeNo
                    }
                };
            }else if (purchaseType=='recharge-purchase') {//充值
                var postData={
                    values:{
                        price:payPrice,
                        system:'ios',
                        buy_item:1,
                        pay_type:3,
                        transactionId:ret.transactionId,
                        receipt:ret.receipt,
                        out_trade_no: severOutTradeNo
                    }
                };
            };

            // 带上公用的接口参数
            postData=mergeCommonParam(postData);

            console.log('交易成功postData:'+$api.jsonToStr(postData));
            ajaxRequest({
                url: '/v1/pay/recharge.php',
                method: 'post',
                dataType: 'json',
                data: postData,
                complete: function (opts, ret, err) {
                    console.log(api.winName + ' ajax url:' + opts.url)

                },
                success: function (ret) {
                    console.log('支付成功，服务器回调：' + JSON.stringify(ret));
                    if (purchaseType == 'vip-purchase') {//开通、续费vip
                        console.log('开通、续费vip成功后回调');
                        api.execScript({
                            name: 'vip_order',
                            script: 'iapFinishCallback();'
                        });
                    } else if (purchaseType == 'recharge-purchase') {//充值
                        // iap支付成功通知回调处理
                        // 更新充值后学习币
                        var xuexibiVal = ret.data.study_coins,
                            sendxuexibiVal = ret.data.send_xuexibi;
                        console.log('更新充值后学习币xuexibiVal:' + xuexibiVal);
                        api.sendEvent({
                            name: 'iapSuccessEvent',
                            extra: {
                                xuexibiVal: xuexibiVal,
                                sendxuexibiVal: sendxuexibiVal,
                                iapPayPrice: payPrice,//内购实际充的金额
                                fromPage: fromPage
                            }
                        });

                        // api.execScript({
                        //     name: 'order',
                        //     frameName: 'order_frame',
                        //     script: 'updateXuexibi("'+xuexibiVal+'");'
                        // });
                        // 刷新个人中心页面
                        // api.execScript({
                        //     name: 'main',
                        //     frameName: 'personal_frame',
                        //     script: 'location.reload();'
                        // });
                    }

                    $api.removePrefs('severOutTradeNo');
                    $api.removePrefs('iapInitEventVal');
                    // 完成指定交易
                    // console.log('retProductId:'+retProductId);
                    iap.finishTransaction({
                        transactionId: retProductId
                    });
                },
                error: function (err) {
                    console.log('支付成功接口回调出错：'+JSON.stringify( err ) );
                }
            });
        }else if(state==2){
            // iap支付失败通知回调处理
            api.sendEvent({
                name: 'iapFailEvent',
            });

            if(purchaseType=='vip-purchase'){
                console.log('开通、续费vip失败后回调');
                api.execScript({
                    name: 'vip_order',
                    script: 'iapFailCallback();'
                });
            }else if (purchaseType=='recharge-purchase') {
                
            }

            var errorCode=ret.errorCode,
                msg='';
            switch (errorCode) {
                case 0:
                    msg='未知错误';
                    break;
                case 1:
                    msg='无效请求';
                    break;
                case 2:
                    msg = '用户取消购买';
                    break;
                case 3:
                    msg='交易无效';
                    break;
                case 4:
                    msg='设备不允许进行充值';
                    break;
                case 5:
                    msg='不是有效商品';
                    break;
                case -1001:
                    msg = '请求超时,请稍后再试';
                    break;
                default:
                    msg = ret.errorMsg;
            }

            // 购买失败回调
            if(errorCode==0){
                alert(ret.errorMsg);
            }else {
                api.toast({
                    msg: msg,
                    duration: 2000,
                    location: 'middle',
                    global:true
                });
            }
        }
    } else {
        console.log('setTransactionListener错误信息:'+JSON.stringify(err));
    }
});

