// 保利威视下载模块
polyvInfoModule = api.require('polyvVideoInfoModule');
polyvDownloadModule = api.require('polyvVideoDownloadModule');
polyvDownloadModule.setDownloadingCallbackIntervalTime({
    seconds: 1
});

// fs文件操作模块
fs = api.require('fs');

// 视频下载
// 正在下载视频本地存储数据初始化
var downloadingData = $api.getStorage('downloadingData');
if (!downloadingData) {
    downloadingData = [];
    $api.setStorage('downloadingData', downloadingData);
} else { //启动应用时有正在下载的视频数据记录（退出应用后再次进入应用，不能继续下载未完成的视频），所以将对应记录下载状态改为下载失败
    var fiData = []
    downloadingData.map(function(item){
        item.download_status = 'failed';
        item.download_status_txt = '下载失败';
        fiData.push(item);
    })
    $api.setStorage('downloadingData', fiData);
}
//已下载完成视频本地存储数据初始化
downloadedData = $api.getStorage('downloadedData');
if (!downloadedData) {
    downloadedData = {'total_size':0};
    $api.setStorage('downloadedData', downloadedData);
}
// 监听下载事件
api.addEventListener({
    name: 'startDownloader'
},function(ret, err) {
    var val = ret.value,
        videodata = val.videodata,
        isPolyv = val.isPolyv
    if (isPolyv) {
        var vid = val.vid;
        polyvDownload(videodata, vid);
    }
});

api.addEventListener({
    name: 'stopPolyAddDownloaderEvent'
},function(ret, err) {
    var val = ret.value,
        vid = val.vid
        stopPolyvDownloader(vid);
});

api.addEventListener({
    name: 'polyAddDownloaderEvent'
},function(ret, err) {
    var val = ret.value,
        data = val.downloadingData;
        // console.log('------开始下载----',JSON.stringify(ret))
        polyAddDownloader(data);
});
//删除下载中视频
api.addEventListener({
    name: 'delePolyDownloading'
},function(ret, err) {
    // console.log('ret',JSON.stringify(ret))
    deletePolyvVideo(ret.value.vid);
});
var downloadFinished = {}; // 控制每个vid是否完成下载，兼容ios bug(回调多次同一个状态)
var downloadready = {}
//全部开始或暂停下载
api.addEventListener({
    name: 'stopOrStartAllEv'
},function(ret, err) {
    if(ret.value.type === 'start'){
        console.log('=====全部开始下载======')
        var downloadingData = $api.getStorage('downloadingData');
        var downloadArr = []
        downloadingData.map(function(item){
            downloadFinished[item.polyv_vid] = false;
            downloadready[item.polyv_vid] = false;
            downloadArr.push({vid: item.polyv_vid, level: 1})
        })
        var param = {downloadArr:downloadArr};
        polyvDownloadModule.addDownloader(param,function(ret, err) {
            Downloader(err, ret)
        })
        if(isIos) startAllPolyvDownload(); 
    } else {
        console.log('=====全部暂停下载======')
        pauseAllPolyvDownload()
    }
});


function polyvDownload(videodata, vid_) {
    var albumInfo = videodata.data.album_info,
        videoInfo = videodata.data.video_info;
    //保利威视视频码率都是：流畅1
    // 判断polyv是否已下载该视频,是就删除重新下载，因为本地数据Storage不存在该id才可以点击下载
    polyvDownloadModule.downloadedVideoExist({
        vid: vid_,
        level: 1
    },function(ret, err) {
        if (ret.exist) {// polvVideo下载文件存在
            deletePolyvVideo(vid_);
        }
        //获取发布文件大小
        polyvInfoModule.getFileSize({
            vid: vid_,
            level: 1
        },function(ret) {
            if (ret) {
                var size = ret.fileSize;
                var video_size = parseInt(size / (1024 * 1024) * 10) / 10;
                // console.log('大小:' + video_size + 'M');
                // 添加下载视频信息到本地数据
                // 值: album_id、album_name、video_no、video_id、video_name、is_polyv、polyv_vid 、mp4_url、视频大小video_size、已下载大小video_downloaded_size、已下载百分比download_percentage、下载状态download_status
                // polyv下载前能读取视频大小，加入下载队列即算入占用空间
                var newDownloadItem={
                    'album_id': albumInfo.album_id,
                    'album_name': albumInfo.album_name,
                    'video_no': videoInfo.video_no,
                    'video_id': videoInfo.video_id,
                    'video_name': videoInfo.video_name,
                    'is_polyv': videoInfo.is_polyv,
                    'polyv_vid': videoInfo.polyv_vid,
                    'mp4_url': videoInfo.mp4_url,
                    'width': videoInfo.width,
                    'height': videoInfo.height,
                    'video_size': video_size,
                    'download_percentage': 0,
                    'video_downloaded_size': 0,
                    'download_status': 'ready',
                    'download_status_txt': '等待中',
                };
                // 获取最新本地下载数据
                var downloadingData = $api.getStorage('downloadingData');
                downloadingData.push(newDownloadItem);
                var vkey = downloadingData.length - 1;
                downloadingData[vkey] = newDownloadItem;
                $api.setStorage('downloadingData',downloadingData);
                api.toast({
                    msg: '已加入缓存列队',
                    duration: 1000,
                    global:true,
                    location: 'middle'
                });
                api.sendEvent({ name: 'downloadNum'});// 通知修改下载中数量变化
                var hasing = false; // 有没有视频正在下载
                downloadingData.map(function(item){
                    if(item.download_status=='downloading'){
                        hasing = true;
                    }
                })
                if(hasing) return;
                polyAddDownloader(downloadingData[vkey]);
            } else {
                api.toast({
                    msg: '读取视频大小失败,请重试',
                    duration: 2000,
                    location: 'middle'
                });
            }
        })
    });
}
// 单个下载，创建一个polyv视频下载器，并添加到下载列表中
function polyAddDownloader(data_) {
    polyvDownloadModule.getDownloadList(function(ret, err){
        var downloadList = ret.downloadList;
        for (var i in downloadList){
            var vid = downloadList[i].vid;
            if (vid == data_.polyv_vid) { // 存在下载列表中
                if (data_.download_status != 'failed') {//非错误状态的直接启动下载
                   startPolyvDownloader(data_.polyv_vid);
                   return;
                } else {
                    deletePolyvVideo(data_.polyv_vid); // 错误的删除后重新下载
                }
            }
        }
        downloadFinished[data_.polyv_vid] = false;
        downloadready[data_.polyv_vid] = false;
        polyvDownloadModule.addDownloader({
            downloadArr: [{vid:data_.polyv_vid, level:1}]
        },function(ret, err) {
            Downloader(err, ret)
        })
    })
}
function Downloader(err,ret) { //处理下载回调
    downloadingData = $api.getStorage('downloadingData');
    if (!err) {
        for (var vid in ret) {
            downloadStatus = ret[vid].downloadStatus;
            if (downloadingData.length == 0) return; //防止回调多次造成错误
            var vkey = 0;
            var video_size = 0;
            downloadingData.map(function(item,index){ //获取下载中列表对应key
                if(item.polyv_vid == vid){
                    vkey = index;
                    video_size = item.video_size;
                }
            })
            if (downloadStatus =='ready') {
                if(isIos&&downloadready[vid]) return;//polyvvideo bug：ios addDownloader会错误返回多次回调ready回调,多次执行该回调，会导致 “重复启动下载操作”问题
                downloadready[vid] = true;
                startPolyvDownloader(vid);
            } else if (downloadStatus =='downloading') { //下载中
                console.log(`下载中...（${downloadingData[vkey].video_name}）`,JSON.stringify(ret))
                var download_percentage = ret[vid].downloadPercentage;
                !download_percentage ? download_percentage = 0 : '';//polyvvdieo bug:前1~2秒,没有返回downloadPercentage字段
                var video_downloaded_size = parseInt(video_size *download_percentage) / 100;
                // 实时更新已存储的下载数据
                if (download_percentage != 0) { // 防止ios前1~2秒没数据返回出现归零情况
                    downloadingData[vkey].download_percentage = download_percentage;
                    downloadingData[vkey].video_downloaded_size =video_downloaded_size;
                }
                downloadingData[vkey].iosStop = false; // 解除暂停状态
                downloadingData[vkey].download_status = downloadStatus;
                downloadingData[vkey].download_status_txt = '下载中';
                // console.log(video_id+'对应vkey:'+vkey+'已下载：',download_percentage,'%--',+downloadingData[vkey]['video_downloaded_size']+'M');
                $api.setStorage('downloadingData',downloadingData);
                api.sendEvent({name: 'downloadingInfoUpdate'});//更新下载状态
            } else if (downloadStatus =='finished') { //下载完成
                downloadedData = $api.getStorage('downloadedData');
                if(isIos && downloadFinished[vid]) return;//polyvvideo bug：ios addDownloader会错误返回多次回调finished回调,同一个vid多次执行该回调，会导致 “开始下载下一个视频时报‘下载器创建失败’”问题
                console.log(`下载完成（${downloadingData[vkey].video_name}）`,JSON.stringify(ret))
                downloadFinished[vid] = true; //阻止同一vid回调多次
                var {video_no, video_id, video_name, is_polyv, polyv_vid, video_size, width, height} = downloadingData[vkey]
                // 更新已下载课程占用空间
                var totalSize = Number(downloadedData.total_size) + Number(video_size);
                downloadedData.total_size = parseInt(Math.ceil(totalSize*10))/10;
                // 添加已下载完成视频的本地数据
                var downloadedVideoObj = { video_no, video_id, video_name, is_polyv, polyv_vid, video_size, width, height };
                // var downloadedVideoObj = { video_no, video_id, video_name, is_polyv, polyv_vid, video_size };
                var albumList = downloadedData.album_list;
                // downloadedData album_list为空{}时，没有album_list属性，表示为插入第一条下载完成的视频数据
                if(!albumList){
                    downloadedData.album_list = [{
                        'album_info': { 
                            album_id:downloadingData[vkey].album_id,
                            album_name:downloadingData[vkey].album_name
                        },
                        'video_list': [downloadedVideoObj]
                    }];
                } else {
                    var hasAlbumLd = false; // 有没有课程id
                    downloadedData.album_list.map(function(item){
                        if(downloadingData[vkey].album_id == item.album_info.album_id){
                            hasAlbumLd = true;
                            var videoList = item.video_list,
                                videoListLen=videoList.length;
                            for (var j = 0; j < videoListLen; j++) {
                                if(downloadingData[vkey].video_no<videoList[j].video_no){
                                    // vkey=j;
                                    // 防止出错，videoList存入空数据
                                    if($api.jsonToStr(downloadedVideoObj)=='{}' || !downloadedVideoObj) break;
                                    videoList.splice(j,0,downloadedVideoObj);
                                    break;
                                }else if(j==videoListLen-1) {// 已遍历至最后，并且当前video_no值大于最后一元素的video_no
                                    // vkey=videoListLen-1;
                                    videoList.push(downloadedVideoObj);
                                }
                            }
                        }
                    })
                    if(!hasAlbumLd){
                        albumList.push({
                            album_info: { 
                                album_id:downloadingData[vkey].album_id,
                                album_name:downloadingData[vkey].album_name
                            },
                            video_list: [downloadedVideoObj]
                        })
                    }
                }
                $api.setStorage('downloadedData',downloadedData);
                
                api.toast({
                    msg: '视频"' +downloadedVideoObj.video_name +'"下载完成',
                    duration: 4000,
                    location: 'middle',
                    global: true
                });
                // 下载完成后删除下载中本地数据
                downloadingData.splice(vkey, 1);
                $api.setStorage('downloadingData',downloadingData);
                api.sendEvent({ name: 'downloadNum',extra: { yesD: true }});// 通知修改下载中数量变化
                api.sendEvent({name: 'downloadingInfoUpdate'});//更新下载状态
                // 下载完后，开始下一个视频下载
                downloadNextVideo();
            } else if (downloadStatus =='stopped') { //下载被停止 
                if (isIos) { // ios一次最多启动三个下载中，其余的都会回调暂停，所以ios的只能通过手动暂停操作,iosStop为是否ios暂停标识。
                    downloadingData[vkey].iosStop = true;
                } else {
                    downloadingData[vkey]['download_status'] = downloadStatus;
                    downloadingData[vkey]['download_status_txt'] = '已暂停';
                }; 
                console.log('被暂停====：',downloadingData[vkey].album_name,downloadingData[vkey].polyv_vid);
                $api.setStorage('downloadingData',downloadingData);
                api.sendEvent({name: 'downloadingInfoUpdate'});//更新下载状态
            } else {
                console.log(`下载失败（${downloadingData[vkey].video_name}）`,JSON.stringify(ret))
                downloadingData[vkey]['download_status'] = downloadStatus;
                downloadingData[vkey]['download_status_txt'] = '下载失败';
                $api.setStorage('downloadingData',downloadingData);
                // 下载失败，开始下一个视频下载（failedInfoUpdate事件中有调用stopDownload方法，该方法内包含"自动开始下一个视频下载"逻辑）
                downloadNextVideo();
                api.toast({
                    msg: '视频"' +downloadingData[vkey]['video_name'] +'"下载失败！',
                    duration: 2000,
                    location: 'middle',
                    global: true
                });
                api.sendEvent({name: 'downloadingInfoUpdate'});//更新下载状态
            }
        }
    } else {
        // console.log('失败222222222222',JSON.stringify(err))
        for (var vid in err) {
            var vkey = 0;
            downloadingData.map(function(item,index){
                if(item.polyv_vid == vid){
                    vkey = index;
                }
            })
            downloadingData[vkey]['download_status'] = 'failed';
            downloadingData[vkey]['download_status_txt'] = '下载失败：' + err[vid];
            $api.setStorage('downloadingData',downloadingData);
            // 下载失败，开始下一个视频下载
            downloadNextVideo();
        }
        api.sendEvent({name: 'downloadingInfoUpdate'});//更新下载状态
    }
}
function downloadNextVideo(hasDownload) {
    downloadingData = $api.getStorage('downloadingData');
    var downloadingLen = downloadingData.length;
    for (var i = 0; i < downloadingLen; i++) {
        if(typeof downloadingData[i]!='object') continue;
        if (downloadingData[i].iosStop && downloadingData[i].download_status=='downloading') { //优先下载ios暂停并且是下载中的
            polyAddDownloader(downloadingData[i]);
            break;
        }
        if(downloadingData[i].download_status=='ready' && !hasDownload){
            polyAddDownloader(downloadingData[i]);
            break;
        }
    }
}
// 启动所有下载(poly)
function startAllPolyvDownload() {
    polyvDownloadModule.startALLDownloader();
}
// 停止所有下载(poly)
function pauseAllPolyvDownload() {
    polyvDownloadModule.stopAllDownloader();
}
// 启动指定视频下载(poly)
function startPolyvDownloader(vid_) {
    polyvDownloadModule.startDownloader({
        vid: vid_
    });
}
// 停止指定视频下载(poly)
function stopPolyvDownloader(vid_) {
    if (isIos) {
        downloadNextVideo(true); //防止如果手动暂停,导致是ios暂停的下载中视频,没法继续下载
    }
    polyvDownloadModule.stopDownloader({
        vid: vid_
    });
}
// 删除指定下载视频(poly)
function deletePolyvVideo(vid_) {
    polyvDownloadModule.deleteVideo({
        vid: vid_
    });
}
