// 保利威视下载模块
polyvInfoModule = api.require('polyvVideoInfoModule');
polyvDownloadModule = api.require('polyvVideoDownloadModule');
polyvDownloadModule.setDownloadingCallbackIntervalTime({
    seconds: 1
});

// fs文件操作模块
fs = api.require('fs');

// downloadManager下载模块
downloadManager = api.require('downloadManager');

// 视频下载
// 正在下载视频本地存储数据初始化
downloadingData = $api.getStorage('downloadingData');
if (!downloadingData) {
    downloadingData = [];
    $api.setStorage('downloadingData', downloadingData);
} else { //启动应用时有正在下载的视频数据记录，因app不支持断点下载（退出应用后再次进入应用，不能继续下载未完成的视频），所以将对应记录下载状态改为下载失败，并调用停止所有下载方法(app意外被掉进程影响app正常加载);进入缓存页点开始下载，实为重新开始下载，
    (function() {
        for (var i = 0; i < downloadingData.length; i++) {
            if(typeof downloadingData[i]!='object') continue;

            var downloadingVideoItem = downloadingData[i];
            if (downloadingVideoItem.is_polyv) {
                var polyv_vid = downloadingVideoItem.polyv_vid;
                deletePolyvVideo(polyv_vid);
            } else {
                var dlmanage_id = downloadingVideoItem.downloadedmanager_id,
                    dlmanage_path = downloadingVideoItem.mp4_url;
                deletedlManagerVideo(dlmanage_id, dlmanage_path);
            }
            downloadingVideoItem.download_status = 'failed';
            downloadingVideoItem.download_status_txt = '下载失败，请重试';
        }
    }());
    $api.setStorage('downloadingData', downloadingData);
    console.log('打开app时downloadingData：'+$api.jsonToStr(downloadingData));
}
//已下载完成视频本地存储数据初始化
downloadedData = $api.getStorage('downloadedData');
if (!downloadedData) {
    downloadedData = {'total_size':0};
    $api.setStorage('downloadedData', downloadedData);
}

// console.log('删除前downloadingData：'+$api.jsonToStr(downloadingData));
// console.log('删除前downloadedData：' + $api.jsonToStr(downloadedData));

// 1.1.17添加缓存排序，本地离线缓存数据结构更改，不兼容以前版本存储的数据结构，需要清除一次本地存储的数据
// $api.rmStorage('clearedDownloadHistory');

var clearedDownloadHistory=$api.getStorage('clearedDownloadHistory');
// console.log('clearedDownloadHistory:'+clearedDownloadHistory);
var isOldFormat=!Array.isArray(downloadingData) || !downloadedData.album_list;
// console.log('isOldFormat:'+isOldFormat);
if(isOldFormat && !clearedDownloadHistory){
    // console.log('首次更新到1.1.17或更高版本,清一次下载记录');

    deleteAllDownloadVideo();

    $api.setStorage('clearedDownloadHistory',true);
}else{
    // console.log('非第一次进入');
}

// 清除所有本地视频下载数据Storage
// 包括poly & mp4 本地Storage数据 以及本地视频文件

// deleteAllDownloadVideo();

function deleteAllDownloadVideo(){
   deleteAllPolyvVideo();
   deleteAlldlManagerVideo();

   setTimeout(function(){
       downloadingData=[];
       $api.setStorage('downloadingData',downloadingData);
       downloadedData = {'total_size':0};
       $api.setStorage('downloadedData', downloadedData);

       // console.log('删除后downloadingData：'+$api.jsonToStr(downloadingData));
       // console.log('删除后downloadedData：'+$api.jsonToStr(downloadedData));
   },1000) 

   // 关闭multi_download页面，保持下载数据同步
   api.closeToWin({
       name: 'multi_download'
   });
   api.closeToWin({
       name: 'video_download'
   });
}

// 监听下载事件
api.addEventListener({
    name: 'startDownloader'
},function(ret, err) {
    console.log(11111222222222,$api.jsonToStr(ret));
    var val = ret.value,
        videodata = val.videodata,
        isPolyv = val.isPolyv,
        isRedownload = val.isRedownload;

    //注意：每次下载前，重新获取一次本地存储数据，以保证downloadingData、downloadedData取到的是最新的本地存储数据
    downloadingData = $api.getStorage('downloadingData');

    downloadedData = $api.getStorage('downloadedData');

    // console.log("开始时downloadingData："+$api.jsonToStr(downloadingData));
    // console.log("开始时downloadedData："+$api.jsonToStr(downloadedData));
    if (isPolyv) {
        var vid = val.vid;
        // 启动polyvVideo下载事件
        // videodata非存全局变量而是参数传入，以支持同时下载多个视频
       polyvDownload(videodata, vid, isRedownload);
    } else {
        var path = val.path;
        // 启动服务器(mp4)下载事件
        serverDownload(videodata, path, isRedownload);
    }
});

api.addEventListener({
    name: 'serverAddDownloaderEvent'
},function(ret, err) {
    var val = ret.value,
        data = val.downloadingData,
        key = val.vkey;

    serverAddDownloader(data,key);
});

api.addEventListener({
    name: 'polyAddDownloaderEvent'
},function(ret, err) {
    var val = ret.value,
        data = val.downloadingData,
        key = val.vkey;

    polyAddDownloader(data,key);
});



//传入isRedownload表示：重新下载，不显示已加入缓存toast提示
function polyvDownload(videodata, vid_, isRedownload) {
    var albumInfo = videodata.data.album_info,
        album_id = albumInfo.album_id,
        videoInfo = videodata.data.video_info,
        video_no = videoInfo.albumvideo_no,
        video_id = videoInfo.video_id,
        video_size = 0,
        video_downloaded_size = 0,
        vkey=0,
        isDownloading=false;
    // 获取视频大小后再执行下载
    // console.log('vid_:' + vid_);

    // 获取最新本地下载数据
    downloadingData = $api.getStorage('downloadingData');
    downloadedData = $api.getStorage('downloadedData');

    var downloadingLen=downloadingData.length;
    // 是否已经正在下载列表中
   for (var i = 0; i < downloadingLen; i++) {
        if(typeof downloadingData[i]!='object') continue;

        if(downloadingData[i]['video_id']==video_id){
            isDownloading=true;

            if(isRedownload){ // 记录重新下载对应的索引、视频大小
                vkey=i;
                video_size = downloadingData[vkey].video_size;
                
                // console.log('重新下载索引：'+vkey);
            }
            break;
        }
    }
    if(isDownloading && !isRedownload){//已在下载列表中(不是下载失败项)
        // console.log(video_id + '已在下载列表中');
        api.toast({
            msg: '该视频正在下载',
            duration: 2000,
            location: 'middle',
            global: true
        });


        // 打开离线缓存页
        // openVideoDownloadWin();
        return;
    }

    //保利威视视频码率都是：流畅1
    // 判断是否已下载该视频
    polyvDownloadModule.downloadedVideoExist({
        vid: vid_,
        level: 1
    },function(ret, err) {
        var vid = ret.vid;
        var exist = ret.exist; //polyv视频是否已下载标识
        var localExist = false; //本地数据Storage该视频是否已下载标识
        // console.log(video_id+' exist1:'+exist);
        if (exist) {// polvVideo下载文件存在
            // app卸载后，本地数据Storage会被清除掉，固应比对一次参数中的vid_对应数据是否存在于本地存储的已下载视频数据中，不存在，删除视频，重新下载
            var albumList=downloadedData.album_list;
            if (!albumList) {// 本地数据Storage为空，调用polyv删除所有下载视频方法，防止重复下载同一视频占用手机存储空间
                deleteAllPolyvVideo();
            } else {
                var albumkey = null,
                    videokey = null;
                (function() { //快速提前退出多重forin循环
                    // downloadedData为空{}时，没有album_list属性，直接退出
                    if (!albumList) return;
                    for (var i = 0; i < albumList.length; i++) {
                        var videoList = albumList[i]['video_list'];
                        for (var j = 0; j < videoList.length; j++) {
                            if (videoList[j]['polyv_vid'] == vid) {
                                // console.log('polyv_vid:'+videoList[j]['polyv_vid'])
                                albumkey = i;
                                videokey = j;

                                localExist = true;

                                return;
                            }
                        }
                    }
                }());
            }

            // console.log(video_id+' localExist:' + localExist);
            if (localExist) { //本地数据Storage也有相关记录
                // api.toast({
                //     msg: '该视频已经在缓存列表中',
                //     duration: 2000,
                //     location: 'middle',
                //     global: true
                // });
                // 打开离线缓存页
                // openVideoDownloadWin();

                 // 已下载过,直接跳转播放
                // console.log(video_id + '已下载过,直接跳转播放');
                api.execScript({
                    name: 'multi_download',
                    frameName: 'multi_download_frame',
                    script: 'playDownloadedVideo("'+album_id+'","'+video_id+'");'
                });
            }else{//本地数据Storage没有相关记录
                // 调用polyv删除指定下载视频方法，防止重复下载同一视频占用手机存储空间
                deletePolyvVideo(vid_);
            }
        }
        
        // 未下载过：polvVideo下载文件不存在
        // 或者 polvVideo下载文件存在，但本地数据Storage数据丢失：app卸载 或 其它异常情况导致
        if (!exist || (exist && !localExist)){
            // console.log('添加下载：'+video_id);

            // 调用下载动画
            api.execScript({
                name: 'multi_download',
                frameName: 'multi_download_frame',
                script: 'addDownloadAni("'+video_id+'");'
            });

            polyvInfoModule.getFileSize({
                vid: vid_,
                level: 1
            },function(ret, err) {
                if (ret) {
                    var size = ret.fileSize;
                    video_size = parseInt(size / (1024 * 1024) * 10) / 10;
                    // console.log(video_id + '大小:' + video_size + 'M');
                } else {
                    // console.log('读取视频大小失败');
                    api.toast({
                        msg: '读取视频大小失败,请重试',
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                // 添加下载视频信息到本地数据
                // 值: album_id、album_name、video_no、video_id、video_name、is_polyv、polyv_vid 、mp4_url、视频大小video_size、已下载大小video_downloaded_size、已下载百分比download_percentage、下载状态download_status
                // polyv下载前能读取视频大小，加入下载队列即算入占用空间
                // mp4视频多出字段：downloadedmanager_id、path
                var newDownloadItem={
                    'album_id': album_id,
                    'album_name': albumInfo.album_name,
                    'video_no': video_no,
                    'video_id': video_id,
                    'video_name': videoInfo.video_name,
                    'is_polyv': videoInfo.is_polyv,
                    'polyv_vid': videoInfo.polyv_vid,
                    'mp4_url': videoInfo.mp4_url,
                    'video_size': video_size,
                    'download_percentage': 0,
                    'video_downloaded_size': 0,
                    'download_status': 'ready',
                    'download_status_txt': '等待中'
                };
                if (!isRedownload) { 
                    downloadingData.push(newDownloadItem);

                    vkey=downloadingData.length-1;
                    // console.log(video_id+'加入自定义下载队列,对应vkey:'+vkey);

                    // 加入下载已添加动画，不需要该提示
                    //非重新下载才显示加入缓存列表提示
                    // api.toast({
                    //     msg: '已加入缓存列表中',
                    //     duration: 2000,
                    //     location: 'middle',
                    //     global: true
                    // });

                }else{
                    downloadingData[vkey]=newDownloadItem;
                }
                $api.setStorage('downloadingData',downloadingData);
                // console.log('downloadingData:'+$api.jsonToStr(downloadingData));

                // 没有正在下载项，则添加到poly下载列表中
                (function(){
                    var downloadingLen=downloadingData.length;
                    for (var i = 0; i < downloadingLen; i++) {
                        if(typeof downloadingData[i]!='object' && i!=downloadingLen-1) continue;

                        // console.log(i+'：'+$api.jsonToStr(downloadingData[i]));
                        if(downloadingData[i]['download_status']=='downloading'){
                            break;
                        }else if(i==downloadingLen-1){ //自定义下载队列中没有正在下载的视频,则添加对应vid_到polyv下载列表中
                            // console.log('当前没有正在下载项，添加新下载');
                            downloadingData[vkey]['download_status']='downloading';
                            downloadingData[vkey]['download_status_txt']='下载中';
                            $api.setStorage('downloadingData',downloadingData);

                            polyAddDownloader(downloadingData[vkey],vkey);
                        }
                    }
                }());
            })

        }
    });
}
// 创建一个polyv视频下载器，并添加到下载列表中
function polyAddDownloader(data_,vkey) {
    var album_id=data_.album_id;
    var video_no=data_.video_no;
    var video_id=data_.video_id;
    var video_size=data_.video_size;
    var vid_=data_.polyv_vid;

    downloadingData = $api.getStorage('downloadingData');

    // console.log('当前添加下载的视频信息：'+$api.jsonToStr(data_));
    var downloadFinished=false;//当前视频是否已下载完成标识
    polyvDownloadModule.addDownloader({
        downloadArr: [{
            vid: vid_,
            level: 1
        }]
    },function(ret, err) {
        if (ret) {
            // console.log('addDownloader ret:'+$api.jsonToStr(ret));
            for (var vid in ret) {
                var statusDict = ret[vid],
                    downloadStatus =statusDict.downloadStatus;
                // console.log(video_id+'下载状态：'+downloadStatus);
                if (downloadStatus =='ready') { //下载器准备就绪
                    // console.log($api.jsonToStr(ret));
                    // 保存用户视频下载中数据

                    // console.log(video_id+'开始下载');

                    polyvDownloadModule.startDownloader({
                        vid: vid
                    });
                    

                    // 打开离线缓存页
                    // openVideoDownloadWin();

                } else if (downloadStatus =='downloading') { //下载中
                    downloadingData = $api.getStorage('downloadingData');
                    // console.log(video_id+"继续开始时downloadingData："+$api.jsonToStr(downloadingData));

                    var download_percentage =statusDict.downloadPercentage;
                    !download_percentage ? download_percentage = 0 : '';//polyvvdieo bug:前1~2秒,没有返回downloadPercentage字段
                    // download_percentage=download_percentage==100?0:download_percentage;//屏蔽出现下载进度条读取到上一下载视频100%状态导致的进度条闪动现象

                    // console.log(video_id+'对应vkey:'+vkey+'已下载百分比：'+ download_percentage +'%');
                    var video_downloaded_size =parseInt(video_size *download_percentage) / 100;
                    // 实时更新已存储的下载数据
                    downloadingData[vkey]['download_percentage'] =download_percentage;
                    downloadingData[vkey]['video_downloaded_size'] =video_downloaded_size;
                    downloadingData[vkey]['download_status'] = downloadStatus;
                    downloadingData[vkey]['download_status_txt'] = '下载中';
                    console.log(video_id+'对应vkey:'+vkey+'已下载：'+downloadingData[vkey]['video_downloaded_size']+'M');
                    $api.setStorage('downloadingData',downloadingData);

                    api.sendEvent({
                        name: 'downloadingInfoUpdate',
                        extra: {
                            video_id:video_id,
                            download_percentage: download_percentage,
                            video_downloaded_size: video_downloaded_size,
                            download_status_txt: '下载中'
                        }
                    });
                    // console.log('下载中downloadingData：'+$api.jsonToStr(downloadingData));
                } else if (downloadStatus =='finished') { //下载完成
                    // console.log('下载完成video_id:'+video_id+',插入的vkey：'+vkey);

                    downloadingData = $api.getStorage('downloadingData');
                    downloadedData = $api.getStorage('downloadedData');

                    // console.log('finished downloadingData：'+$api.jsonToStr(downloadingData));
                    // console.log('finished downloadedData：'+$api.jsonToStr(downloadedData));

                    if (downloadFinished) return;//polyvvideo bug：ios addDownloader会错误返回多次回调finished回调,多次执行该回调，会导致 “开始下载下一个视频时报‘下载器创建失败’”问题
                    downloadFinished = true;

                    api.toast({
                        msg: '视频"' +downloadingData[vkey]['video_name'] +'"下载完成',
                        duration: 4000,
                        location: 'middle',
                        global: true
                    });


                    // 更新已下载课程占用空间
                    // total_size 保留一位小数，单位M
                    downloadedData.total_size+=downloadingData[vkey].video_size;
                    downloadedData.total_size=parseInt(Math.ceil(downloadedData.total_size*10))/10;

                    // 添加已下载完成视频的本地数据
                    // 键：album_id
                    // 值: album_name、video_id 、video_name、is_polyv、polyv_vid、mp4_url、视频大小video_size、
                    //不要取polyvDownload方法参数中的video_id(addDownloader中取到的非独立)等信息，改为取初始ready中保存的值
                    var downloadedVideoObj = {
                        'video_no': downloadingData[vkey].video_no,
                        'video_id': downloadingData[vkey].video_id,
                        'video_name': downloadingData[vkey].video_name,
                        'is_polyv': downloadingData[vkey].is_polyv,
                        'polyv_vid': downloadingData[vkey].polyv_vid,
                        'mp4_url': downloadingData[vkey].mp4_url,
                        'video_size': downloadingData[vkey].video_size
                    };

                    var albumList=downloadedData.album_list,
                        albumkey=null,
                        videokey=null;
                    (function(){//快速提前退出多重forin循环
                        // downloadedData album_list为空{}时，没有album_list属性，表示为插入第一条下载完成的视频数据
                        if(!albumList){
                            downloadedData.album_list = [{
                                'album_info': {
                                    'album_id': downloadingData[vkey].album_id,
                                    'album_name': downloadingData[vkey].album_name
                                },
                                'video_list': [downloadedVideoObj]
                            }];
                            return;
                        }

                        albumList=downloadedData.album_list;
                        var albumlistLen=albumList.length;
                        // console.log('完成更新前albumList长度：'+albumlistLen);
                        for (var i = 0; i < albumlistLen; i++) {
                            // console.log('for循环时albumList长度：'+albumlistLen);
                            if(album_id==albumList[i].album_info.album_id){//album_id存在
                                var videoList=albumList[i]['video_list'],
                                    videoListLen=videoList.length;
                                for (var j = 0; j < videoListLen; j++) {
                                   if(video_no<videoList[j].video_no){
                                       // vkey=j;
                                       // 防止出错，videoList存入空数据
                                       if($api.jsonToStr(downloadedVideoObj)=='{}' || !downloadedVideoObj) break;
                                       videoList.splice(j,0,downloadedVideoObj);
                                       break;
                                   }else if(j==videoListLen-1) {// 已遍历至最后，并且当前video_no值大于最后一元素的video_no
                                       // vkey=videoListLen-1;
                                       videoList.push(downloadedVideoObj);
                                   }
                               }
                               break;
                            }else if(i==albumlistLen-1){// 已遍历至最后,album_id不存在
                                albumList.push({
                                    'album_info': {
                                        'album_id': downloadingData[vkey].album_id,
                                        'album_name': downloadingData[vkey].album_name
                                    },
                                    'video_list': [downloadedVideoObj]
                                })
                            }
                        }
                        
                    }());

                    $api.setStorage('downloadedData',downloadedData);
                    // console.log('下载完后downloadedData:'+$api.jsonToStr(downloadedData));

                    // 下载完成后，不能直接splice删除对应正在下载中视频的本地数据，因需要根据索引值来更新对应的正在下载的视频信息
                    // 改成下载完后，将对应下载对象替换成video_id占位
                    downloadingData[vkey]=video_id;
                    // 遍历downloadingData,如果全部为video_id占位则清空一次downloadingData即赋值downloadingData=[]
                    (function(){
                        var downloadingLen=downloadingData.length;
                        for (var i = 0; i < downloadingLen; i++) {
                            if(typeof downloadingData[i]=='object'){
                                break;
                            }else if(i==downloadingLen-1){
                                downloadingData=[];
                            }
                        }
                    }());
                    $api.setStorage('downloadingData',downloadingData);
                    // console.log('下载完后downloadingData:'+$api.jsonToStr(downloadingData));

                    api.sendEvent({
                        name: 'finishedInfoUpdate',
                        extra: {
                            album_id: album_id,
                            video_id: video_id
                        }
                    });

                    // 下载完后，开始下一个视频下载
                    downloadNextVideo();

                } else if (downloadStatus =='stopped') { //下载被停止
                    //下载完成，也会执行一次停止事件
                    // console.log(video_id+'被暂停');
                    // console.log('被暂停：'+$api.jsonToStr(downloadingData[vkey]));
                    // if (!downloadingData[vkey]) return;
                    // downloadingData[vkey]['download_status'] = downloadStatus;
                    // downloadingData[vkey]['download_status_txt'] = '已暂停';
                    // $api.setStorage('downloadingData',downloadingData);

                    // stop回调video_id、vkey有误、回调中不设置downloadingData，直接在video_download_frame.html stopDownload()中控制更新downloadingData，并在此回调中读取最新downloadingData数据

                    downloadingData = $api.getStorage('downloadingData');
                     // console.log("暂停后downloadingData："+$api.jsonToStr(downloadingData));
                } else {
                    downloadingData[vkey]['download_status'] = downloadStatus;
                    downloadingData[vkey]['download_status_txt'] = '下载失败';
                    $api.setStorage('downloadingData',downloadingData);

                    // console.log('下载失败');
                    api.sendEvent({
                        name: 'failedInfoUpdate',
                        extra: {
                            video_id: video_id,
                            download_status_txt: '下载失败'
                        }
                    });

                    // 下载失败，开始下一个视频下载（failedInfoUpdate事件中有调用stopDownload方法，该方法内包含"自动开始下一个视频下载"逻辑）
                    // downloadNextVideo();

                }
            }

        } else {
            console.log(video_id+' addDownloader:'+$api.jsonToStr(err));
            api.toast({
                msg: video_id +$api.jsonToStr(err),
                location: 'middle',
                duration: 4000,
            });
        }
    })
    
}
// 开始下载下一个视频
function downloadNextVideo(){
    downloadingData=$api.getStorage('downloadingData');
    var downloadingLen=downloadingData.length;
    for (var i = 0; i < downloadingLen; i++) {
        if(typeof downloadingData[i]!='object') continue;

        if(downloadingData[i].download_status=='ready'){
            var videoid=downloadingData[i].video_id;
            if(downloadingData[i].is_polyv){ //保利威视视频
                if(downloadingData[i]['video_downloaded_size']>0){//已添加过polyv下载器
                    // console.log(videoid+'已添加过polyv下载器,直接开始下载');
                    startPolyvDownloader(downloadingData[i].polyv_vid);
                }else{
                    // console.log(videoid+'添加polyv下载器，再下载');
                    polyAddDownloader(downloadingData[i],i);
                }
            }else { //服务器mp4视频
                if(downloadingData[i]['downloadedmanager_id']!=null){//已添加过downloadManager下载器
                    // console.log(videoid+'已添加过downloadManager下载器,直接开始下载');
                    startdlManagerDownloader(downloadingData[i]['downloadedmanager_id']);
                }else{
                    // console.log(videoid+'添加downloadManager下载器，再下载');
                    serverAddDownloader(downloadingData[i],i);
                }
            }
            break;
        }
    }
}
// 启动所有下载(poly)
function startAllPolyvDownload() {
    polyvDownloadModule.startALLDownloader();
}
// 停止所有下载(poly)
function pauseAllPolyvDownload() {
    polyvDownloadModule.stopAllDownloader();
}
// 启动指定视频下载(poly)
function startPolyvDownloader(vid_) {
    polyvDownloadModule.startDownloader({
        vid: vid_
    });
}
// 停止指定视频下载(poly)
function stopPolyvDownloader(vid_) {
    polyvDownloadModule.stopDownloader({
        vid: vid_
    });
}
// 删除所有下载视频(poly)
function deleteAllPolyvVideo() {
    polyvDownloadModule.deleteAllVideo();
}
// 删除指定下载视频(poly)
function deletePolyvVideo(vid_) {
    polyvDownloadModule.deleteVideo({
        vid: vid_
    });
}

// 服务器(mp4)下载事件
function serverDownload(videodata, path_, isRedownload) {
    var albumInfo = videodata.data.album_info,
        album_id = albumInfo.album_id,
        videoInfo = videodata.data.video_info,
        video_no = videoInfo.albumvideo_no,
        video_id = videoInfo.video_id,
        video_size = 0,
        video_downloaded_size = 0,
        vkey=0,
        isDownloading=false;

    // 获取最新本地下载数据
    downloadingData = $api.getStorage('downloadingData');
    downloadedData = $api.getStorage('downloadedData');

    var downloadingLen=downloadingData.length;
    // 是否已经正在下载列表中
   for (var i = 0; i < downloadingLen; i++) {
        if(typeof downloadingData[i]!='object') continue;

        if(downloadingData[i]['video_id']==video_id){
            isDownloading=true;

            if(isRedownload){ // 记录重新下载对应的索引、视频大小
                vkey=i;
                video_size = downloadingData[vkey].video_size;

                // console.log('重新下载索引：'+vkey);
            }
            break;
        }
    }

    if(isDownloading && !isRedownload){//已在下载列表中(不是下载失败项)
        // console.log(video_id + '已在下载列表中');
        api.toast({
            msg: '该视频正在下载',
            duration: 2000,
            location: 'middle',
            global: true
        });


        // 打开离线缓存页
        // openVideoDownloadWin();
        return;
    }

    // 判断是否已下载该视频
    // console.log('path2:'+path_);
    var startPos = path_.lastIndexOf('/') + 1,
        fileName = path_.slice(startPos);
    // console.log(video_id+' fileName：'+fileName);

    fs.exist({
        path: 'fs://download/' + fileName
    },function(ret, err) {
        var exist = ret.exist; //mp4视频是否已下载标识
        var localExist = false; //本地数据Storage该视频是否已下载标识
        // console.log(video_id+' exist2:'+exist);
        if (exist) {//mp4下载文件存在
            // app卸载后，本地数据Storage会被清除掉，固应比对一次参数中的vid_对应数据是否存在于本地存储的已下载视频数据中，不存在，删除视频，重新下载
            var albumList=downloadedData.album_list;
            if (!albumList) {// 本地数据Storage为空，调用downloadManager删除所有下载视频方法，防止重复下载同一视频占用手机存储空间
                deleteAlldlManagerVideo();
            } else {
                var albumkey = null,
                    videokey = null;
                (function() { //快速提前退出多重forin循环
                    // downloadedData为空{}时，没有album_list属性，直接退出
                    if (!albumList) return;
                    for (var i = 0; i < albumList.length; i++) {
                        var videoList = albumList[i]['video_list'];
                        for (var j = 0; j < videoList.length; j++) {
                            if (videoList[j]['mp4_url'] == path_) {
                                // console.log('mp4_url:'+videoList[j]['mp4_url'])
                                albumkey = i;
                                videokey = j;

                                localExist = true;

                                return;
                            }
                        }
                    }
                }());

            }

            // console.log(video_id+' localExist:' + localExist);
            if (localExist) {//本地数据Storage也有相关记录
                // api.toast({
                //     msg: '该视频已经在缓存列表中',
                //     duration: 2000,
                //     location: 'middle',
                //     global: true
                // });
                // 打开离线缓存页
                // openVideoDownloadWin();

                // 已下载过,直接跳转播放
                // console.log(video_id + '已下载过,直接跳转播放');
                api.execScript({
                    name: 'multi_download',
                    frameName: 'multi_download_frame',
                    script: 'playDownloadedVideo("'+album_id+'","'+video_id+'");'
                });
            }else {//本地数据Storage没有相关记录
                // 调用downloadManager删除指定下载视频方法，防止重复下载同一视频占用手机存储空间
                // 本地已下载数据没有相关记录，无法查找到对应的id_,改调fs模块remove()方法删除文件
                //deletedlManagerVideo(id_,path_);
                fs.remove({
                    path: 'fs://download/' + fileName
                }, function(ret, err) {
                    console.log(JSON.stringify(ret));
                });
            }
            
        } else { //下载文件被删除啦
            // console.log('文件被删除啦');
            // api.toast({
            //     msg: '缓存文件丢失，重新下载',
            //     duration: 2000,
            //     location: 'middle',
            //     global: true
            // });
            // // 更新本地存储数据downloadedData,防止文件被手动删除后，downloadedData数据重复
            // upDateDownloadedData(video_id);
            
            // // 添加下载前，调用下载动画
            // api.execScript({
            //     name: 'multi_download',
            //     frameName: 'multi_download_frame',
            //     script: 'addDownloadAni("'+video_id+'");'
            // });
        }

        // 未下载过：mp4下载文件不存在
        // 或者 mp4下载文件存在，但本地数据Storage数据丢失：app卸载 或 其它异常情况导致
        if(!exist || (exist && !localExist)){
            // console.log('添加下载：'+video_id);

            // 调用下载动画
            api.execScript({
                name: 'multi_download',
                frameName: 'multi_download_frame',
                script: 'addDownloadAni("'+video_id+'");'
            });

            // 添加下载视频信息到本地数据
            // 值:album_id、album_name、video_no、video_id、video_name、is_polyv、polyv_vid 、mp4_url、视频大小video_size、已下载大小video_downloaded_size、已下载百分比download_percentage、下载状态download_status、downloadedmanager下载记录id、文件保存路径path
            // 存储的download_status字段属性值跟polyv保持一致
            // mp4视频video_size需要执行downloadManager的query方法才能获取到，获取后再写入更新downloadingData 对应vkey 下的video_size
            var newDownloadItem = {
                'album_id': album_id,
                'album_name': albumInfo.album_name,
                'video_no': video_no,
                'video_id': video_id,
                'video_name': videoInfo.video_name,
                'is_polyv': videoInfo.is_polyv,
                'polyv_vid': videoInfo.polyv_vid,
                'mp4_url': videoInfo.mp4_url,
                'video_size': '未知',
                'download_percentage': 0,
                'video_downloaded_size': 0,
                'download_status': 'ready',
                'download_status_txt': '等待中',
                'downloadedmanager_id': null,
                'path': 'fs://download/' + fileName
            };
            if (!isRedownload) { 
                downloadingData.push(newDownloadItem);

                vkey=downloadingData.length-1;
                // console.log(video_id+'加入自定义下载队列,对应vkey:'+vkey);

                // 加入下载已添加动画，不需要该提示
                //非重新下载才显示加入缓存列表提示
                // api.toast({
                //     msg: '已加入缓存列表中',
                //     duration: 2000,
                //     location: 'middle',
                //     global: true
                // });

            }else{
                downloadingData[vkey]=newDownloadItem;
            }
            $api.setStorage('downloadingData',downloadingData);

            // 没有正在下载项，则添加到mp4下载列表中
            (function(){
                var downloadingLen=downloadingData.length;
                for (var i = 0; i < downloadingLen; i++) {
                    if(typeof downloadingData[i]!='object' && i!=downloadingLen-1) continue;

                    // console.log(i+'：'+$api.jsonToStr(downloadingData[i]));
                    if(downloadingData[i]['download_status']=='downloading'){
                        break;
                    }else if(i==downloadingLen-1){ //自定义下载队列中没有正在下载的视频,则添加对应vid_到polyv下载列表中
                        // console.log('当前没有正在下载项，添加新下载');
                        downloadingData[vkey]['download_status']='downloading';
                        downloadingData[vkey]['download_status_txt']='下载中';
                        $api.setStorage('downloadingData',downloadingData);

                        serverAddDownloader(downloadingData[vkey],vkey);
                    }
                }
            }());
           
        }

    })

}
// 更新本地存储数据downloadedData(防止mp4视频文件被手动删除)
function upDateDownloadedData(vid_) {
    var albumList=downloadedData.album_list,
        albumkey=null,
        videokey=null;
    (function(){//快速提前退出多重forin循环
        if(!albumList) return;
        for (var i = 0; i < albumList.length; i++) {
            var videoList=albumList[i]['video_list'];
            for (var j = 0; j < videoList.length; j++) {
                if(videoList[j]['video_id']==vid_){
                    albumkey=i;
                    videokey=j;

                    var dlmanager_id=videoList[videokey]['downloadedmanager_id'],
                        dlmanager_path=videoList[videokey]['path'];
                    // 删除downloadManager下载记录
                    api.execScript({
                        name: 'root',
                        script: 'deletedlManagerVideo("'+dlmanager_id+'","'+dlmanager_path+'");'
                    });
                    // console.log('已删除被删文件'+dlmanager_path+'的下载记录');

                    // console.log('删除前downloadedData：'+$api.jsonToStr(downloadedData));
                    // 删除数组某元素
                    videoList.splice(videokey,1);
                    //videoList数组长度为0，直接删除album_list下对应albumid对象
                    if(videoList.length==0){
                         albumList.splice(albumkey,1);
                    }
                    //album_list数组长度为0，直接清空downloadedData对象
                    if(albumList.length==0){
                         downloadedData={};
                    }
                    $api.setStorage('downloadedData',downloadedData);

                    // console.log('删除后downloadedData：'+$api.jsonToStr(downloadedData));

                    return;
                }
            }
        }
    }());
}

function serverAddDownloader(data_,vkey) {
    var video_id=data_.video_id;
    var mp4_url=data_.mp4_url;
    var path=data_.path;

    // console.log(video_id+' mp4_url：'+mp4_url);
    // console.log(video_id+' path：'+path);

    downloadingData = $api.getStorage('downloadingData');

    downloadManager.enqueue({
        url: mp4_url,
        savePath: path,
        cache: true,
        //allowResume为false才能重新下载
        allowResume: true,
        networkTypes: 'all'
    },function(ret, err) {
        if (ret) {
            var id = ret.id;
            console.log(video_id+' vkey:'+vkey+' 对应创建的下载id:'+id);

            // 更新downloadingData vkey对应downloadedmanager_id
            // downloadingData[vkey]['downloadedmanager_id']=String(id);
            downloadingData[vkey]['downloadedmanager_id']=id;
            $api.setStorage('downloadingData',downloadingData);

            // 更新downloadedmanager_id
            // api.sendEvent({
            //     name: 'dlmanagerIdUpdate',
            //     extra: {
            //         video_id: video_id,
            //         downloadedmanager_id: id
            //     }
            // });


            // downloadManager 需要添加定时器，查询更新当前下载状态
            // data_: downloadingData对应vkey 更新后的数据
            downloadManagerQuery(downloadingData[vkey],vkey);

        } else {
            console.log('enqueue:'+JSON.stringify(err));
            api.toast({
                msg: $api.jsonToStr(err),
                location: 'middle'
            });
        }
    });


}

function downloadManagerQuery(data_,vkey) { // data_=downloadingData[vkey]
    // console.log('下载状态循环查询');
    if(typeof data_ =='undefined') return;//下载完成前最后一次1秒后延时查询可能获取到的data_为undefined

    var album_id=data_.album_id;
    var video_no=data_.video_no;
    var video_id=data_.video_id;
    var video_size=data_.video_size;

    // console.log('vkey:'+vkey);
    // console.log('data_2:'+$api.jsonToStr(data_));

    var id_=data_.downloadedmanager_id;
    // console.log(video_id+'对应id_:'+id_);
    downloadManager.query({
        ids: [id_]
    },function(ret, err) {
        if (ret) {
            // console.log($api.jsonToStr(ret));
            // 防止删除正在下载的视频，还在setTimeout查询下载状态
            if(!ret.data) return;

            var data = ret.data[0],
                status = data.status,
                url=data.url,
                savePath=data.savePath,
                totalSize=data.totalSize,
                finishSize=data.finishSize;

            console.log(video_id +'下载状态:'+status);

            // console.log(video_id+'video_size:'+data_.video_size);

            if (totalSize == -1) { //downloadManager 返回错误状态totalSize=-1时
                console.log(video_id +'downloadManager 返回错误状态 totalSize=-1');
                window.setTimeout(function() {
                    downloadManagerQuery(data_,vkey);
                },1000)
                return false;
            }

            if(totalSize>0 && typeof data_.video_size=='string'){//totalSize>0 && data_.video_size=='未知'
                // downloadManager bug : android下status没有0状态返回
                // 本应在status=0中执行
                // 更新downloadingData vkey对应video_size
                video_size = parseInt(totalSize / (1024 * 1024) *10) / 10;
                // console.log(video_id + '大小2:' + video_size + 'M');

                downloadingData[vkey]['video_size']=video_size;
                $api.setStorage('downloadingData',downloadingData);
                // console.log('获取到mp4大小后写入downloadingData2:'+$api.jsonToStr(downloadingData));
                
            }

            if (status == 0) { //下载器准备就绪
                console.log(video_id+'准备好下载啦');

                window.setTimeout(function() {
                    downloadManagerQuery(data_,vkey);
                },1000)

            } else if (status == 1) { //下载中,下载状态同polyv统一为：downloading
                var video_downloaded_size = parseInt(finishSize / (1024 * 1024) * 10) / 10,
                    download_percentage = parseInt(video_downloaded_size / video_size * 100);
                // download_percentage=download_percentage==100?0:download_percentage;//屏蔽出现下载进度条读取到上一下载视频100%状态导致的进度条闪动现象
                // console.log('下载中video_id:' +video_id+'对应vkey2:'+vkey+'已下载百分比2：'+ download_percentage +'%');

                downloadingData = $api.getStorage('downloadingData');
                // 实时更新已存储的下载数据
                downloadingData[vkey]['download_percentage'] =download_percentage;
                downloadingData[vkey]['video_downloaded_size'] =video_downloaded_size;
                downloadingData[vkey]['download_status'] = 'downloading';
                downloadingData[vkey]['download_status_txt'] = '下载中';
                // console.log(video_id+'已下载2：'+downloadingData[vkey]['video_downloaded_size']+'M');
                $api.setStorage('downloadingData', downloadingData);

                api.sendEvent({
                    name: 'downloadingInfoUpdate',
                    extra: {
                        video_id: video_id,
                        download_percentage: download_percentage,
                        video_size: downloadingData[vkey]['video_size'],
                        video_downloaded_size: video_downloaded_size,
                        download_status_txt: '下载中'
                    }
                });
                // 定时查询当前下载状态
                window.setTimeout(function() {
                    console.log(video_id +'定时查询当前下载状态');
                    downloadManagerQuery(downloadingData[vkey],vkey);
                },1000)
            } else if (status == 2) { //下载被暂停,下载状态同polyv统一为：stopped
                // 下载被停止（polyv addDownloader bug: 无stopped回调，统一在stopDownload()方法中手动存储下载中被暂停数据）
                // console.log(video_id+'下载被停止');
                // downloadingData[video_id]['download_status'] ='stopped';
                // downloadingData[video_id]['download_status_txt'] ='已暂停';
                // $api.setStorage('downloadingData', downloadingData);

                // api.execScript({
                //     name:'video_download',
                //     frameName:'video_download_frame',
                //     script:'downloadStatusSwitch("'+video_id+'")'
                // })


                // poly stop回调video_id、vkey有误、统一在此回调中不设置downloadingData，直接在video_download_frame.html stopDownload()中控制更新downloadingData，并在此回调中读取最新downloadingData数据
                downloadingData = $api.getStorage('downloadingData');
                // console.log("暂停后downloadingData："+$api.jsonToStr(downloadingData));
            } else if (status == 3) { //下载完成,下载状态同polyv统一为：finished
                console.log('下载完成video_id:'+video_id+',插入的vkey：'+vkey);

                downloadingData = $api.getStorage('downloadingData');
                downloadedData = $api.getStorage('downloadedData');

                api.toast({
                    msg: '视频"' + downloadingData[vkey]['video_name'] + '"下载完成',
                    duration: 4000,
                    location: 'middle',
                    global: true
                });

                // 更新已下载课程占用空间
                // total_size 保留一位小数，单位M
                downloadedData.total_size+=downloadingData[vkey].video_size;
                downloadedData.total_size=parseInt(Math.ceil(downloadedData.total_size*10))/10;

                // 添加已下载完成视频的本地数据
                // 键：album_id
                // 值: album_name、video_id 、video_name、is_polyv、polyv_vid、mp4_url、视频大小video_size、downloadedmanager下载记录id、文件保存路径path
                var downloadedVideoObj = {
                    'video_no': downloadingData[vkey].video_no,
                    'video_id': downloadingData[vkey].video_id,
                    'video_name': downloadingData[vkey].video_name,
                    'is_polyv': downloadingData[vkey].is_polyv,
                    'polyv_vid': downloadingData[vkey].polyv_vid,
                    'mp4_url': downloadingData[vkey].mp4_url,
                    'video_size': downloadingData[vkey].video_size,
                    'downloadedmanager_id': downloadingData[vkey].downloadedmanager_id,
                    'path': downloadingData[vkey].path
                };

                var albumList=downloadedData.album_list,
                    albumkey=null,
                    videokey=null;
                (function(){//快速提前退出多重forin循环
                    // downloadedData album_list为空{}时，没有album_list属性，表示为插入第一条下载完成的视频数据
                    if(!albumList){
                        downloadedData.album_list = [{
                            'album_info': {
                                'album_id': downloadingData[vkey].album_id,
                                'album_name': downloadingData[vkey].album_name
                            },
                            'video_list': [downloadedVideoObj]
                        }];
                        return;
                    }

                    albumList=downloadedData.album_list;
                    var albumlistLen=albumList.length;
                    // console.log('完成更新前albumList长度2：'+albumlistLen);
                    for (var i = 0; i < albumlistLen; i++) {
                        // console.log('for循环时albumList长度2：'+albumlistLen);
                        if(album_id==albumList[i].album_info.album_id){//album_id存在
                            var videoList=albumList[i]['video_list'],
                                videoListLen=videoList.length;
                            for (var j = 0; j < videoListLen; j++) {
                               if(video_no<videoList[j].video_no){
                                   // vkey=j;
                                   // 防止出错，videoList存入空数据
                                   if($api.jsonToStr(downloadedVideoObj)=='{}' || !downloadedVideoObj) break;
                                   videoList.splice(j,0,downloadedVideoObj);
                                   break;
                               }else if(j==videoListLen-1) {// 已遍历至最后，并且当前video_no值大于最后一元素的video_no
                                   // vkey=videoListLen-1;
                                   videoList.push(downloadedVideoObj);
                               }
                           }
                           break;
                        }else if(i==albumlistLen-1){// 已遍历至最后,album_id不存在
                            albumList.push({
                                'album_info': {
                                    'album_id': downloadingData[vkey].album_id,
                                    'album_name': downloadingData[vkey].album_name
                                },
                                'video_list': [downloadedVideoObj]
                            })
                        }
                    }
                    
                }());

                $api.setStorage('downloadedData',downloadedData);
                // console.log('下载完后downloadedData:'+$api.jsonToStr(downloadedData));
                
                // 下载完成后，不能直接splice删除对应正在下载中视频的本地数据，因需要根据索引值来更新对应的下载信息
                // 改成下载完后，将对应下载对象替换成video_id占位
                downloadingData[vkey]=video_id;
                // 遍历downloadingData,如果全部为video_id占位则清空一次downloadingData即赋值downloadingData=[]
                (function(){
                    var downloadingLen=downloadingData.length;
                    for (var i = 0; i < downloadingLen; i++) {
                        if(typeof downloadingData[i]=='object'){
                            break;
                        }else if(i==downloadingLen-1){
                            downloadingData=[];
                        }
                    }
                }());
                $api.setStorage('downloadingData',downloadingData);
                // console.log('下载完后downloadingData:'+$api.jsonToStr(downloadingData));

                api.sendEvent({
                    name: 'finishedInfoUpdate',
                    extra: {
                        album_id: album_id,
                        video_id: video_id
                    }
                });

                // 下载完后，开始下一个视频下载
                downloadNextVideo();
                
            } else { //下载状态：4,下载状态同polyv统一为：failed
                api.toast({
                    msg: '视频"' + downloadingData[vkey]['video_name'] + '"下载失败(error code '+data.reason+')',
                    duration: 4000,
                    location: 'middle',
                    global: true
                });

                downloadingData[vkey]['download_status'] = 'failed';
                downloadingData[vkey]['download_status_txt'] ='下载失败';
                $api.setStorage('downloadingData', downloadingData);

                api.sendEvent({
                    name: 'failedInfoUpdate',
                    extra: {
                        video_id: video_id,
                        download_status_txt: '下载失败'
                    }
                });

                // 下载失败，开始下一个视频下载（failedInfoUpdate事件中有调用stopDownload方法，该方法内包含"自动开始下一个视频下载"逻辑）
                // downloadNextVideo();

            }
        } else {
            console.log('query:'+JSON.stringify(err));
            api.toast({
                msg: $api.jsonToStr(err),
                location: 'middle'
            });
        }
    });
}

// 启动所有下载(downloadManager)
function startAlldlManagerDownload() {
    for (var i = 0; i < downloadingData.length; i++) {
        if(typeof downloadingData[i]!='object') continue;

        if (downloadingData[i].is_polyv) return;

        var dlManager_id = downloadingData[i].downloadedmanager_id;
        startdlManagerDownloader(dlManager_id);
    }
}
// 停止所有下载(downloadManager)
function pauseAlldlManagerDownload() {
    for (var i = 0; i < downloadingData.length; i++) {
        if(typeof downloadingData[i]!='object') continue;

        if (downloadingData[i].is_polyv) return;

        var dlManager_id = downloadingData[i].downloadedmanager_id;
        stopdlManagerDownloader(dlManager_id);
    }
}
// 启动指定视频下载(downloadManager)
function startdlManagerDownloader(id_) {
    console.log('继续下载id:'+id_);
    downloadManager.resume({
        id: id_
    },function(ret, err) {
        console.log(JSON.stringify(ret));
        console.log(JSON.stringify(err));
        if (ret.status) {
            console.log(JSON.stringify(ret));

            // downloadManager 需要添加定时器，查询更新当前下载状态
            for (var i = 0; i < downloadingData.length; i++) {
                if(typeof downloadingData[i]!='object') continue;

                if(downloadingData[i]['downloadedmanager_id']==id_){
                    var data_=downloadingData[i];

                    downloadManagerQuery(data_, i);
                    break;
                }
            }
        } else {
            console.log('resume：' + JSON.stringify(err));
            api.toast({
                msg: $api.jsonToStr(err),
                location: 'middle'
            });
        }
    });
}
// 停止指定视频下载(downloadManager)
function stopdlManagerDownloader(id_) {
    // console.log('id_:'+id_);
    downloadManager.pause({
        id: id_
    },function(ret, err) {
        if (ret.status) {
            // console.log(JSON.stringify(ret));
        } else {
            // console.log(JSON.stringify(err));
        }
    });
}
// 删除所有下载视频(downloadManager)
function deleteAlldlManagerVideo() {
    var albumList=downloadedData.album_list,
        albumkey=null,
        videokey=null;
    (function(){//快速提前退出多重forin循环
        // downloadedData为空{}时，没有album_list属性，直接退出
        if(!albumList) return;
        for (var i = 0; i < albumList.length; i++) {
            var videoList=albumList[i]['video_list'];
            for (var j = 0; j < videoList.length; j++) {
                var videoInfo = videoList[j];
                if (videoInfo.is_polyv) return;
                var dlManager_id = videoInfo['downloadedmanager_id'],
                    path = videoInfo['path'];
                // console.log(dlManager_id);
                // console.log(path);
                deletedlManagerVideo(dlManager_id, path);
            }
        }
    }());
}
// 删除指定下载视频(downloadManager)
function deletedlManagerVideo(id_, path_) {
    // 清除downloadManager下载记录（包括删除文件）
    downloadManager.remove({
        ids: [id_],
        deleteFiles: true
    },
    function(ret, err) {
        if (ret) {
            console.log('删除视频下载记录个数：'+ret.number);

            // 删除downloadManager下载对应的本地文件(预防deleteFiles失效)
            fs.remove({
                path: path_
            },function(ret, err) {
                console.log(path_ + '被删除');
            });
        } else {
            console.log('remove:'+JSON.stringify(err));
            api.toast({
                msg: $api.jsonToStr(err),
                location: 'middle'
            });
        }
    });
}

// 获取最新的downloadingData
function getDownloadingData(){
    downloadingData = $api.getStorage('downloadingData');
}

// 打开离线缓存页
function openVideoDownloadWin() {
    openNavWin({
        name: 'video_download',
        url: './html/course/video_download.html',
        title:'离线缓存',
        pageParam: {
            name: 'test'
        }
    })
}
